#!/usr/bin/ruby
# encoding: utf-8

require "celluloid/autostart"
require "celluloid/io" #event based TCPServer instead of TCPServer in 'soket'

class Server
  include Celluloid::IO
  finalizer :shutdown

  def initialize(serverPort)
    @serverSocket = TCPServer.new("0.0.0.0", serverPort)
    @serverSocket.listen(10000)
    @concurrentClientCount = 0
    async.acceptLoop
  end

  def acceptLoop
    loop { async.processClient @serverSocket.accept }
  end

  def processClient(clientSocket)
    begin
      @concurrentClientCount += 1
      puts "#{@concurrentClientCount} concurrent clients are connected"
      #неполный запрос от клиентов (продолжение которого еще не доставилось по сети)
      dataForProcessing = ""
      loop do
        data = clientSocket.recv(100000)
        puts "Data received: "+data
        data.force_encoding('utf-8')
        queries = dataForProcessing + data
        queries = queries.split("\r\n",-1)
        dataForProcessing = queries[-1]
        queries.delete_at(-1)
        queries.each do |query|
          words = query.split(" ")
          answer = (eval words[2]+words[1]+words[3]).to_s + "\r\n"
          clientSocket << answer
          puts "Answer: "+answer
        end
      end
    rescue EOFError
      clientSocket.close rescue nil
      @concurrentClientCount -= 1
    rescue Exception => e
      puts "There was exception: " + e.to_s + "\n"+e.backtrace.join("\n")
      shutdown
    end
  end

  def shutdown
    @serverSocket.close rescue nil
  end
end

server = Server.new(28563)
sleep
